#include "skse/PluginAPI.h"
#include "skse/skse_version.h"

#define DCF_VERSION 3

WNDPROC oldWndProc = NULL;
HANDLE hThread = NULL;

LRESULT CALLBACK MyWndProc(__in  HWND hWnd, __in  UINT uMsg, __in  WPARAM wParam, __in  LPARAM lParam)
{
	switch ( uMsg )
	{
	case WM_ACTIVATE:
		{
			if(LOWORD(wParam) > 0)
			{
				while(ShowCursor(FALSE) > -1);
			}
			else
			{
				while(ShowCursor(TRUE) < 0);
			}
		}
	}
	return CallWindowProc(oldWndProc, hWnd, uMsg, wParam, lParam);
}

DWORD WINAPI MyThreadProc( LPVOID lpThreadParameter )
{
	while(!oldWndProc)
	{
		HWND hWnd = FindWindow("Skyrim",NULL);
		if(hWnd && hWnd != INVALID_HANDLE_VALUE)
		{
			oldWndProc = (WNDPROC) SetWindowLongPtr(hWnd,GWLP_WNDPROC,(LONG_PTR)MyWndProc);
		}
		Sleep(1000);
	}
	CloseHandle(hThread);
	return 0;
}

extern "C"
{

bool SKSEPlugin_Query(const SKSEInterface * skse, PluginInfo * info)
{
	// populate info structure
	info->infoVersion =	PluginInfo::kInfoVersion;
	info->name =		"DCF_plugin";
	info->version =		DCF_VERSION + 1;

	if(skse->isEditor)
	{
		return false;
	}
	return true;
}

bool SKSEPlugin_Load(const SKSEInterface * skse)
{
	hThread = CreateThread(NULL,NULL,MyThreadProc,NULL,NULL,NULL);
	return true;
}

};
